% An example of how to use the dcm4che toolkit from matlab for file
% reading or other dicom functions.
%
% authors: dimitri.pianeta@gmail.com
% version : june 2010
%
% An example of how to use the dcm4che toolkit from matlab for file
% reading or other dicom functions.
%
% Step 1 is to download the toolkit from www.dcm4che.org. Select the
% dcm4che2 tookit 'bin' archive, and unzip it.
%
% Then add the java libraries to your path
%version 2
%
% Example: 
%  readDcm4che2_2('D:\CHU\stage10\dcm4che2
%  matlab\dcm4che-2.0.22-bin\dcm4che-2.0.22\lib\','D:\CHU\stage10\pr
%  ojet original et finale\00000001'')
% 
% 
%pathDcm4che = 'D:\langage
%informatique\dcm4che\dcm4che-2.0.25-bin\dcm4che-2.0.25\lib\';
%testfile = 'C:\Users\Dimitri\Desktop\00000000';
% fileInput : path package java dcm4che2 
% pathDcm4che : path package dcm4che2
% fileInput: noun and path file extension .dcm or no-extension dicom
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function imageFinal = readDcm4che3(pathDcm4che,  fileInput )
checkjava = which('org.dcm4che2.io.DicomInputStream');
if isempty(checkjava)
   
    libpath = pathDcm4che; 
    javaaddpath([libpath 'dcm4che-core-3.2.1.jar']);
    javaaddpath([libpath 'dcm4che-image-3.2.1.jar']);
    javaaddpath([libpath 'dcm4che-imageio-3.2.1.jar']);
    javaaddpath([libpath 'dcm4che-net-3.2.1.jar'])
    
    javaaddpath([libpath 'slf4j-api-1.6.1.jar']);
    javaaddpath([libpath 'slf4j-log4j12-1.6.1.jar']);
    javaaddpath([libpath 'log4j-1.2.16.jar']);
 end

% Now create a reader as follows (other examples on dcm4che wiki)
testfile = [fileInput ];
%testfile = ['C:\Users\Dimitri\Desktop\dfn\S040005'];

din = org.dcm4che.io.DicomInputStream(...
    java.io.BufferedInputStream(java.io.FileInputStream(testfile)));
%din.setIncludeBulkData(org.dcm4che.io.DicomInputStream.IncludeBulkData.URI);
%fmi = dis.readFileMetaInformation();
dataset = din.readDataset(-1, -1);






pixeldata = dataset.getInts(org.dcm4che.data.Tag.PixelData);

% You can access the fields like this:

rows = dataset.getInt(org.dcm4che.data.Tag.Rows, 0);
disp(rows)
 
cols = dataset.getInt(org.dcm4che.data.Tag.Columns,0);
disp(cols)

%pixeldata = dcm.getInts(org.dcm4che.data.Tag.PixelData);

img = reshape(pixeldata, cols,rows);
 image = zeros(rows,cols);
 for i =1 :rows-1
     for j=1 :cols-1
  image(i, j)= img(cols-j,i);
     end
 end

imageFinal=image(1:rows,cols:-1:1);

imshow(imageFinal,[])
% figure(1);
% imshow(imageFinal,[]);
% title('Picture original');