%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Transformation matrice Tag.PixelData with change Tag.Rows and Tag.Lows
% --> Output Path + noun fileOutput 
%
% authors: dimitri.pianeta@gmail.com
% version : april 2016
%
% An example of how to use the dcm4che toolkit from matlab for file
% reading or other dicom functions.
%
% Step 1 is to download the toolkit from www.dcm4che.org. Select the
% dcm4che2 tookit 'bin' archive, and unzip it.
%
% Then add the java libraries to your path
%
% Example: 
% pathDcm4che = 'D:\CHU\stage10\dcm4che2 matlab\dcm4che-3.3.7-bin\dcm4che-3.3.7\lib\'
% image: matrice 
% fileInput = 'D:\CHU\stage10\projet original et finale\00000001';
% pathOutput = 'C:\Users\Dimitri\Desktop\final2';
% fileOutput = 'essai.dcm';
% 
% @param: 
% pathDcm4che : path package java dcm4che2 
% fileInput: noun and path file extension .dcm or no-extension dicom
% pathOutput : path file output
% fileOutput: noun file output
% image : new pixel matrice  
% 
%
% @ version : 4
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function  output_args  = writenMatrice3(pathDcm4che ,image, fileInput,  pathOutput, fileOutput, nameMethod  )

%   Detailed explanation goes here

checkjava = which('org.dcm4che3.io.DicomInputStream');
if isempty(checkjava)
   
    libpath = pathDcm4che; 
    javaaddpath([libpath 'dcm4che-core-3.3.7.jar']);
    javaaddpath([libpath 'dcm4che-image-3.3.7.jar']);
    javaaddpath([libpath 'dcm4che-imageio-3.3.7.jar']);
    javaaddpath([libpath 'dcm4che-net-3.2.1.jar'])
    
    javaaddpath([libpath 'slf4j-api-1.7.5.jar']);
    javaaddpath([libpath 'slf4j-log4j12-1.7.5.jar']);
    javaaddpath([libpath 'log4j-1.2.17.jar']);
 end
 
 
% Now create a reader as follows (other examples on dcm4che wiki)
testfile = [fileInput ];
%testfile = ['C:\Users\Dimitri\Desktop\dfn\S040005'];

encOpts = org.dcm4che3.io.DicomEncodingOptions.DEFAULT;

din = org.dcm4che.io.DicomInputStream(...
    java.io.BufferedInputStream(java.io.FileInputStream(testfile)));
dataset = din.readDataset(-1, -1);
fmi = din.getFileMetaInformation();

%fileOutput 

testFile2 = [pathOutput '\'  fileOutput];
 
rows = size(image,1);%give rows image
cols = size(image,2);%give ligne image
  
img = zeros(cols,rows);
for i =1 :rows-1
    for j=1 :cols-1
% img(rows-j, i)= image(i,j);
 img(j, i)=image(i,cols-j);
    end
end

%imageFinale =  img(rows:-1:1,1:1:cols);%Change matrice 
imageFinale =  img( cols:-1:1,1:1:rows);%Change matrice 
img = reshape(imageFinale, 1, rows*cols);%Reshape array

 

  dataset.setInt(rg.dcm4che3.data.Tag.PixelData, org.dcm4che3.data.VR.OW, img); 
                                           
dataset.setInt(org.dcm4che3.data.Tag.Rows,org.dcm4che3.data.VR.US,rows); // New Rows
dataset.setInt(org.dcm4che3.data.Tag.Columns, org.dcm4che3.data.VR.US,columns);// New Columns
dataset.setString(org.dcm4che3.data.Tag.PatientName,org.dcm4che3.data.VR.PN,nameMethod);
				
				 
				
dos =org.dcm4che3.io.DicomOutputStream(...
                    java.io.BufferedOutputStream(java.io.FileOutputStream(testFile2)));	%BufferedOutput	     	
        dos.setEncodingOptions(encOpts);
        dos.writeDataset(fmi, dataset);
        dos.finish();
        dos.flush();